<div *ngIf="errorMessage; else noError" class="alert alert-warning">
    <strong>Warning!</strong> {{errorMessage | json}}
</div>
  
  <ng-template #noError>
    <div *ngIf="!this.svg; else elseLoading">
      <app-loading-screen></app-loading-screen>
    </div>
  </ng-template>
  
  <ng-template #elseLoading>
  
    <p>The current "As is" model</p>
  
    <div class="mx-5">
      <app-zoom-pan-container class="svg-models" #models>
        <div [innerHTML]="svg"></div>
      </app-zoom-pan-container>
    </div>
  
    <div class="container">
      <button class="btn btn-success" id="buttonResetView" (click)="models.reset()">Reset view</button>
    </div>

    <!-- Action Buttons-->
    <div class="container">
        <!-- button viewAdaptations-->
        <div *ngIf="this.viewAdaptationsClicked;">
            <button class="btn btn-success" id="buttonViewAdaptations" (click)="viewAdaptations()">View Adaptations</button>
        </div>
        <div *ngIf="!this.viewAdaptationsClicked;">
            <button class="btn btn-danger" id="buttonViewAdaptations" (click)="viewAdaptations()" >View Adaptations</button>
        </div>
        <!--Button "changeAttribute"-->
        <div *ngIf="this.changeAttributeClicked;">
            <button class="btn btn-success" id="buttonChangeAttribute" (click)="changeAttribute()" >Change Attribute</button>
        </div>
        <div *ngIf="!this.changeAttributeClicked;">
            <button class="btn btn-danger" id="buttonChangeAttribute" (click)="changeAttribute()" >Change Attribute</button>
        </div>
        <!--button addNode-->
        <div *ngIf="this.addNodeClicked;">
            <button class="btn btn-success" id="buttonAddNode" (click)="addNode()" >Add Node</button>
        </div>
        <div *ngIf="!this.addNodeClicked;">
            <button class="btn btn-danger" id="buttonAddNode" (click)="addNode()" >Add Node</button>
        </div>
        <!-- button addRelation-->
        <div *ngIf="this.addRelationClicked;">
            <button class="btn btn-success" id="buttonAddRelation" (click)="addRelation()" >Add Relation</button>
        </div>
        <div *ngIf="!this.addRelationClicked;">
            <button class="btn btn-danger" id="buttonAddRelation" (click)="addRelation()">Add Relation</button>
        </div>
        <!-- button deleteNode-->
        <div *ngIf="this.deleteNodeClicked;">
            <button class="btn btn-success" id="buttonDeleteNode" (click)="deleteNode()">Delete Node</button>
        </div>
        <div *ngIf="!this.deleteNodeClicked;">
            <button class="btn btn-danger" id="buttonDeleteNode" (click)="deleteNode()">Delete Node</button>
        </div>
        <!-- button deleteRelation-->
        <div *ngIf="this.deleteRelationClicked;">
            <button class="btn btn-success" id="buttonDeleteRelation" (click)="deleteRelation()">Delete Relation</button>
        </div>
        <div *ngIf="!this.deleteRelationClicked;">
            <button class="btn btn-danger" id="buttonDeleteRelation" (click)="deleteRelation()">Delete Relation</button>
        </div>
    </div>

    <div class="container-fluid" id="alertNoCorrectValueSelected" *ngIf="clickedConfirmIncorrectValue == true;">
      <ngb-alert width="100%" type="danger" (closed)="clickedConfirmIncorrectValue = false">
        <strong>Warning!</strong> The selected action cannot be confirmed because of incorrect values.
      </ngb-alert>
    </div>
  
    <!-- Tables to execute the chosen actions-->
    <!-- Change Attribute -->
    <div class="container-fluid mt-2" *ngIf="this.changeAttributeClicked;">
        <div class="row app-container p-2">
          <div class="col-lg-12 offset-md-0">
    
            <p>Change an attribute of a node</p>
    
            <div class="table-responsive">
                <table class="table table-condensed">
    
                <tr>
                    <th width="20%">Node</th>
                    <th width="20%">Attribute</th>
                    <th width="20%">Current Value</th>
                    <th width="20%">New Value</th>
                    <th width="20%">Actions</th>
                </tr>
    
                <tbody>
                  <!--Node IDs-->
                  <td class="overflow-hidden">
                    <div ngbDropdown container="body">
                      <button class="btn btn-outline-primary btn-sm" ngbDropdownToggle>{{ this.nodeIDButtonName }}</button>
                      <div ngbDropdownMenu>
                        <button ngbDropdownItem *ngFor="let node of this.nodes" (click)="selectNodeID(node)">{{ node.ATZeichenid }}</button>
                      </div>
                    </div>
                  </td>
                  <!-- Attribute to be changed-->
                  <td class="overflow-hidden">
                    <div ngbDropdown container="body">
                      <button class="btn btn-outline-primary btn-sm" ngbDropdownToggle>{{ this.currentAttribute }}</button>
                      <div ngbDropdownMenu>
                        <button ngbDropdownItem *ngFor="let att of this.listOfAttributes" (click)="selectAttribute(att)">{{att}}</button>
                      </div>
                    </div>
                  </td>  
                  <!--Current Value (kein Drop Down)-->  
                  <td class="overflow-hidden">
                    <div>{{ this.currentAttributeValue }}</div>
                  </td>  
                  <!--New Value (manchmal Drop Down, manchmal nicht)-->
                  <td class="overflow-hidden">
                    <!--Drop Down-->
                    <div ngbDropdown container="body" *ngIf="this.dropdown">
                      <button class="btn btn-outline-primary btn-sm" ngbDropdownToggle>{{ this.currentChange }}</button>
                      <div ngbDropdownMenu>
                        <button ngbDropdownItem *ngFor="let newVal of this.changeDropDown" (click)="selectNewValue(newVal)">{{ newVal }}</button>
                      </div>
                    </div>
                    <!--Textfield-->
                    <div class="form-group" *ngIf="this.textfield">
                      <input type="text" id="value" name="value" [(ngModel)]="value" class="form-control" placeholder="Enter new value for the attribute">
                    </div>
                    <!--Boolean-->
                    <div *ngIf="this.Boolean">
                      {{ this.changedBoolean }}
                    </div>
                      
                  </td>
                  <!-- Actions -> confirm selection -->
                  <td>
                    <div class="btn btn-danger" [attr.id]="attributeChange" (click)="changeConfirmed();">
                      Confirm Change
                    </div>
                  </td>  
                </tbody>
    
                </table>
            </div>
          </div>
        </div>
      </div>

      <!-- Add Node -->
      <div class="container-fluid mt-2" *ngIf="this.addNodeClicked;">
        <div class="row app-container p-2">
          <div class="col-lg-12 offset-md-0">
    
            <p>Change an attribute of a node</p>
    
            <div class="table-responsive">
                <table class="table table-condensed">
    
                <tr>
                    <th width="40%">Node type</th>
                    <th width="40%">Node Name</th>
                    <th width="20%">Actions</th>
                </tr>
    
                <tbody>
                  <!--Node Types-->
                  <td class="overflow-hidden">
                    <div ngbDropdown container="body">
                      <button class="btn btn-outline-primary btn-sm" ngbDropdownToggle>{{this.typenode}}</button>
                      <div ngbDropdownMenu>
                        <button ngbDropdownItem *ngFor="let nodetype of this.nodeTypes" (click)="selectNodeType(nodetype)">{{ nodetype }}</button>
                      </div>
                    </div>
                  </td>  
                  <!--Node Name-->  
                  <td class="overflow-hidden">
                    <div class="form-group">
                      <input type="text" id="value" name="value" [(ngModel)]="value" class="form-control" placeholder="Enter a name for the new node">
                    </div>
                  </td>  
                  <!-- Actions -> confirm selection -->
                  <td>
                    <div class="btn btn-danger" [attr.id]="attributeChange" (click)="additionNode();">
                      Confirm Change
                    </div>
                  </td>  
                </tbody>
    
                </table>
            </div>
          </div>
        </div>
      </div>

      <!-- Delete Node -->
      <div class="container-fluid mt-2" *ngIf="this.deleteNodeClicked;">
        <div class="row app-container p-2">
          <div class="col-lg-12 offset-md-0">
    
            <p>Delete a node</p>
    
            <div class="table-responsive">
                <table class="table table-condensed">
    
                <tr>
                    <th width="80%">Node</th>
                    <th width="20%">Actions</th>
                </tr>
    
                <tbody>
                  <!--Node IDs-->
                  <td class="overflow-hidden">
                    <div ngbDropdown container="body">
                      <button class="btn btn-outline-primary btn-sm" ngbDropdownToggle>{{ this.nodeIDButtonName }}</button>
                      <div ngbDropdownMenu>
                        <button ngbDropdownItem *ngFor="let node of this.nodes" (click)="selectNodeID(node)">{{ node.ATZeichenid }}</button>
                      </div>
                    </div>
                  </td>
                  <!-- Actions -> confirm selection -->
                  <td>
                    <div class="btn btn-danger" [attr.id]="deleteNode" (click)="deletionNode();">
                      Confirm Deletion
                    </div>
                  </td>  
                </tbody>
    
                </table>
            </div>
          </div>
        </div>
      </div>

      <!-- Delete Relation -->
      <div class="container-fluid mt-2" *ngIf="this.deleteRelationClicked;">
        <div class="row app-container p-2">
          <div class="col-lg-12 offset-md-0">
    
            <p>Delete a relation</p>
    
            <div class="table-responsive">
                <table class="table table-condensed">
    
                <tr>
                    <th width="26%">Start Node ID</th>
                    <th width="26%">Target Node ID</th>
                    <th width="28%">Relation Name</th>
                    <th width="20%">Actions</th>
                </tr>
    
                <tbody>
                  <!-- Start Node IDs-->
                  <td class="overflow-hidden">
                    <div ngbDropdown container="body">
                      <button class="btn btn-outline-primary btn-sm" ngbDropdownToggle>{{ this.nodeIDButtonName }}</button>
                      <div ngbDropdownMenu>
                        <button ngbDropdownItem *ngFor="let node of this.nodes" (click)="selectNodeID(node)">{{ node.ATZeichenid }}</button>
                      </div>
                    </div>
                  </td>
                  <!-- Target Node IDs -->
                  <td class="overflow-hidden">
                    <div ngbDropdown container="body">
                      <button class="btn btn-outline-primary btn-sm" ngbDropdownToggle>{{ this.targetnodeIDButtonName}}</button>
                      <div ngbDropdownMenu>
                        <button ngbDropdownItem *ngFor="let tnode of this.targetnodes" (click)="selectTargetNodeID(tnode)">{{ tnode.ATZeichenid }}</button>
                      </div>
                    </div>
                  </td>
                  <!-- Relation Name -->
                  <td class="overflow-hidden">
                    <div ngbDropdown container="body">
                      <button class="btn btn-outline-primary btn-sm" ngbDropdownToggle>{{ this.relationButtonName }}</button>
                      <div ngbDropdownMenu>
                        <button ngbDropdownItem *ngFor="let relation of this.possibleRelations" (click)="selectRelation(relation)">{{ relation.relationname }}</button>
                      </div>
                    </div>
                  </td>
                  <!-- Actions -> confirm selection -->
                  <td>
                    <div class="btn btn-danger" [attr.id]="deleteNode" (click)="deletionRelation();">
                      Confirm Deletion
                    </div>
                  </td>  
                </tbody>
    
                </table>
            </div>
          </div>
        </div>
      </div>

      <!-- Add Relation -->
      <div class="container-fluid mt-2" *ngIf="this.addRelationClicked;">
        <div class="row app-container p-2">
          <div class="col-lg-12 offset-md-0">
    
            <p>Add a relation</p>
    
            <div class="table-responsive">
                <table class="table table-condensed">
    
                <tr>
                    <th width="25%">Start Node ID</th>
                    <th width="25%">Target Node ID</th>
                    <th width="30%">Relation Name</th>
                    <th width="20%">Actions</th>
                </tr>
    
                <tbody>
                  <!-- Start Node IDs-->
                  <td class="overflow-hidden">
                    <div ngbDropdown container="body">
                      <button class="btn btn-outline-primary btn-sm" ngbDropdownToggle>{{ this.nodeIDButtonName }}</button>
                      <div ngbDropdownMenu>
                        <button ngbDropdownItem *ngFor="let node of this.nodes" (click)="selectNodeID(node)">{{ node.ATZeichenid }}</button>
                      </div>
                    </div>
                  </td>
                  <!-- Target Node IDs -->
                  <td class="overflow-hidden">
                    <div ngbDropdown container="body">
                      <button class="btn btn-outline-primary btn-sm" ngbDropdownToggle>{{ this.targetnodeIDButtonName}}</button>
                      <div ngbDropdownMenu>
                        <button ngbDropdownItem *ngFor="let tnode of this.targetnodes" (click)="selectTargetNodeID(tnode)">{{ tnode.ATZeichenid }}</button>
                      </div>
                    </div>
                  </td>
                  <!-- Relation Name -->
                  <td class="overflow-hidden">
                    <div ngbDropdown container="body">
                      <button class="btn btn-outline-primary btn-sm" ngbDropdownToggle>{{ this.relationNameDropDown}}</button>
                      <div ngbDropdownMenu>
                        <button ngbDropdownItem *ngFor="let rel of this.listOfRelationNames" (click)="selectRelationName(rel)">{{ rel }}</button>
                      </div>
                    </div>
                  </td>
                  <!-- Actions -> confirm selection -->
                  <td>
                    <div class="btn btn-danger" [attr.id]="deleteNode" (click)="additionRelation();">
                      Confirm Addition
                    </div>
                  </td>  
                </tbody>
    
                </table>
            </div>
          </div>
        </div>
      </div>


      <!-- View Adaptations -->
    
  </ng-template>
  